#include <windows.h>

// http://www.asahi-net.or.jp/~KH4S-SMZ/spi/make_spi.html ̃Tv\[Xɓ
#include "spi00in.h"


/***************************************************************************
 * SPI֐
 * ܂؂͂ōς܂Ă.
 ***************************************************************************/
static const char *pluginfo[] = {
	"00IN",				/* Plug-in API o[W */
	"AN HTTPD Cache",		/* Plug-in,o[Wy copyright */
	"*.JPG;*.JPEG;*.PNG;*.GIF",			/* \IȊgq ("*.JPG" "*.JPG;*.JPEG" Ȃ) */
	"IMAGE file(*.JPG;*.JPEG;*.PNG;*.GIF)",	/* t@C` */
};

#pragma pack(push)
#pragma pack(1) //\̂̃oE1oCgɂ
typedef struct BMP_FILE {
	BITMAPFILEHEADER	header;
	BITMAPINFOHEADER	info;
	RGBQUAD				pal[1];
} BMP_FILE;
#pragma pack(pop)

//wb_`FbNɕKvȃTCY.2KBȓ.
#define HEADBUF_SIZE sizeof(BMP_FILE)

BOOL IsSupportedEx(char *filename, char *data);
int GetPictureInfoEx(char *data, struct PictureInfo *lpInfo);
int GetPictureEx(long datasize, HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData, char *data);

HMODULE hSpiJpeg;
HMODULE hSpiPng;
HMODULE hSpiGif;

int (__stdcall *IS_Jpeg)(LPSTR filename, DWORD dw);
int (__stdcall *GPI_Jpeg)(LPSTR buf,long len, unsigned int flag, PictureInfo *lpInfo);
int (__stdcall *GP_Jpeg)(LPSTR buf,long len, unsigned int flag,
			 HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData);

int (__stdcall *IS_Png)(LPSTR filename, DWORD dw);
int (__stdcall *GPI_Png)(LPSTR buf,long len, unsigned int flag, PictureInfo *lpInfo);
int (__stdcall *GP_Png)(LPSTR buf,long len, unsigned int flag,
			 HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData);

int (__stdcall *IS_Gif)(LPSTR filename, DWORD dw);
int (__stdcall *GPI_Gif)(LPSTR buf,long len, unsigned int flag, PictureInfo *lpInfo);
int (__stdcall *GP_Gif)(LPSTR buf,long len, unsigned int flag,
			 HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData);



/* Gg|Cg */
BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	hSpiJpeg=LoadLibrary("ifjpeg.spi");
	hSpiPng=LoadLibrary("ifpng.spi");
	hSpiGif=LoadLibrary("ifgif.spi");
	
	IS_Jpeg=GetProcAddress(hSpiJpeg,"IsSupported");
	GPI_Jpeg=GetProcAddress(hSpiJpeg,"GetPictureInfo");
	GP_Jpeg=GetProcAddress(hSpiJpeg,"GetPicture");

	IS_Png=GetProcAddress(hSpiPng,"IsSupported");
	GPI_Png=GetProcAddress(hSpiPng,"GetPictureInfo");
	GP_Png=GetProcAddress(hSpiPng,"GetPicture");

	IS_Gif=GetProcAddress(hSpiGif,"IsSupported");
	GPI_Gif=GetProcAddress(hSpiGif,"GetPictureInfo");
	GP_Gif=GetProcAddress(hSpiGif,"GetPicture");

	return TRUE;
}



int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
	if (infono < 0 || infono >= (sizeof(pluginfo) / sizeof(char *))) 
		return 0;

	lstrcpyn(buf, pluginfo[infono], buflen);

	return lstrlen(buf);
}

int __stdcall IsSupported(LPSTR filename, DWORD dw)
{
	char *data;
	char buff[HEADBUF_SIZE];
	DWORD ReadBytes;

	if ((dw & 0xFFFF0000) == 0) {
	/* dw̓t@Cnh */
		if (!ReadFile((HANDLE)dw, buff, HEADBUF_SIZE, &ReadBytes, NULL)) {
			return 0;
		}
		data = buff;
	} else {
	/* dw̓obt@ւ̃|C^ */
		data = (char *)dw;
	}
	/* tH[}bgmF */
	if(strncmp(data,"HTTP",4)==0){
		return TRUE;
	}
	return FALSE;
}

int __stdcall GetPictureInfo
(LPSTR buf, long len, unsigned int flag, struct PictureInfo *lpInfo)
{
	int ret = SPI_OTHER_ERROR;
	char headbuf[HEADBUF_SIZE];
	char *data;
	char *len2;
	char *data2;
	char *filename;
	HANDLE hf;
	DWORD ReadBytes;


	if ((flag & 7) == 0) {
	/* buf̓t@C */
		hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hf == INVALID_HANDLE_VALUE) return SPI_FILE_READ_ERROR;
		if (SetFilePointer(hf, len, NULL, FILE_BEGIN) != (DWORD)len) {
			CloseHandle(hf);
			return SPI_FILE_READ_ERROR;
		}
		if (!ReadFile(hf, headbuf, HEADBUF_SIZE, &ReadBytes, NULL)) {
			CloseHandle(hf);
			return SPI_FILE_READ_ERROR;
		}
		CloseHandle(hf);
		if (ReadBytes != HEADBUF_SIZE) return SPI_NOT_SUPPORT;
		data = headbuf;
		filename = buf;
	} else {
		data = (char *)buf;
		filename = NULL;
	}
	
	//LbVȂꍇΉ
	if(IsSupported(filename,data)==TRUE){
		data2=strstr(data,"\r\n\r\n")+4;
		len2=len-(data2-data);
	}else{
		data2=data;
		len2=len;
	}

	if((*IS_Jpeg)(filename,(DWORD)data2)){
		ret = (*GPI_Jpeg)(data2,len2,0x01,lpInfo);
	}else if((*IS_Png)(filename,(DWORD)data2)){
		ret = (*GPI_Png)(data2,len2,0x01,lpInfo);
	}else if((*IS_Gif)(filename,(DWORD)data2)){
		ret = (*GPI_Gif)(data2,len2,0x01,lpInfo);
	}else{
		ret = SPI_NOT_SUPPORT;
	}
	return ret;
}

int __stdcall GetPicture(
		LPSTR buf, long len, unsigned int flag, 
		HANDLE *pHBInfo, HANDLE *pHBm,
		SPI_PROGRESS lpPrgressCallback, long lData)
{
	int ret = SPI_OTHER_ERROR;
	char *data;
	char *len2;
	char *data2;
	char *filename;
	long datasize;
	HANDLE hf;
	DWORD ReadBytes;

	char b[1000];
	if ((flag & 7) == 0) {
	/* buf̓t@C */
		hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hf == INVALID_HANDLE_VALUE) return SPI_FILE_READ_ERROR;
		datasize = GetFileSize(hf, NULL) -len;
		if (datasize < HEADBUF_SIZE) {
			CloseHandle(hf);
			return SPI_NOT_SUPPORT;
		}
		if (SetFilePointer(hf, len, NULL, FILE_BEGIN) != (DWORD)len) {
			CloseHandle(hf);
			return SPI_FILE_READ_ERROR;
		}
		data = (char *)LocalAlloc(LMEM_FIXED, datasize);
		if (data == NULL) {
			CloseHandle(hf);
			return SPI_NO_MEMORY;
		}
		if (!ReadFile(hf, data, datasize, &ReadBytes, NULL)) {
			CloseHandle(hf);
			LocalFree(data);
			return SPI_FILE_READ_ERROR;
		}
		CloseHandle(hf);
		if (ReadBytes != (DWORD)datasize) {
			LocalFree(data);
			return SPI_FILE_READ_ERROR;
		}
		filename = buf;
	} else {
	/* buf̓t@CC[Wւ̃|C^ */
		data = buf;
		datasize = len;
		filename = NULL;
	}

	//LbVȂꍇΉ
	if(IsSupported(filename,data)==TRUE){
		data2=strstr(data,"\r\n\r\n")+4;
		len2=len-(data2-data);
	}else{
		data2=data;
		len2=len;
	}

	if((*IS_Jpeg)(filename,(DWORD)data2)){
		ret = (*GP_Jpeg)(data2,len2,0x01,pHBInfo,pHBm,lpPrgressCallback,lData);
	}else if((*IS_Png)(filename,(DWORD)data2)){
		ret = (*GP_Png)(data2,len2,0x01,pHBInfo,pHBm,lpPrgressCallback,lData);
	}else if((*IS_Gif)(filename,(DWORD)data2)){
		ret = (*GP_Gif)(data2,len2,0x01,pHBInfo,pHBm,lpPrgressCallback,lData);
	}else{
		ret = SPI_NOT_SUPPORT;
	}
	if ((flag & 7) == 0) LocalFree(data);
	return ret;
}

int __stdcall GetPreview(
	LPSTR buf, long len, unsigned int flag,
	HANDLE *pHBInfo, HANDLE *pHBm,
	SPI_PROGRESS lpPrgressCallback, long lData)
{
	return SPI_NO_FUNCTION;
}
